function love.load()
	fon = love.graphics.newFont("fixed.ttf",8);
	love.graphics.setFont(fon);
	love.graphics.setMode(80*6+1,24*10+1)
	love.graphics.setCaption("7DRL Challenge Challenge");
	love.keyboard.setKeyRepeat(125,30);
	generatemap = love.filesystem.load("gen.lua");
	jumping=0;
	mapdynams={"door","opened","dx","dy"};
	mapdynams.door={};
	mapdynams.opened={};
	mapdynams.dx={};
	mapdynams.dy={};
	player = {
	x=39;
	y=10;
	r=255;
	g=160;
	b=0;
	symbol="A";
	name="";
	pos="";
	sparking = 0;
	timer=600;
	gameover=0;
	ro=0;
	levels=1;
	}
	require "player.lua";
	colors = {
	{"#",255,255,255},
	{".",128,128,128},
	{"+",100,50,0},
	{"*",60,60,60}
	}
	mapx=80;
	mapy=24;
	start=1;
	map=[[
................................................................................
................................................................................
................................................................................
................................................................................
.....................................You........................................
......................................|.........................................
......................................V.........................................
................................................................................
...................................###+###......................................
...............................######+.+######..................................
####################++#################################++#######################
###################++######7DRL#Challenge#Challenge#####++######################
###################++###################################++######################
###################++########Press#Space#to#start#######++######################
####################++#################################++#######################
..................................(legend)......................................
.................................>.=.stairs.....................................
..................................#.=.walls.....................................
........................O.=.holes.(can.be.jumped.over)..........................
................................................................................
..................................(controls)....................................
..................................numpad=move...................................
....................shift+numpad=jump.(only in four directions).................
................................................................................]]
	
	love.graphics.setLineStyle("rough");
	--game="";
end

--[[function golor(str,bg)
	if bg == 0 then
		if str == "@" then
			love.graphics.setColor(player.colorred,player.coloryellow,player.colorblue,255);
		end
		if str =="#" then
			love.graphics.setColor(255,255,255,255)
		end
		if str == "." then
			love.graphics.setColor(0,128,0,255)
		end
		if str == "+" then
			love.graphics.setColor(140,0,64,255)
		end
		if str == ">" then
			ylw=128+math.random(64);
			love.graphics.setColor(ylw,ylw,0)
		end
	else
		if str == "@" then
			love.graphics.setColor(player.colorred/1.5,player.coloryellow/1.5,player.colorblue/1.5,255);
		end
		if str =="#" then
			love.graphics.setColor(255/1.5,255/1.5,255/1.5,255/1.5)
		end
		if str == "." then
			love.graphics.setColor(0,128/1.5,0,255/1.5)
		end
		if str == "+" then
			love.graphics.setColor(140/1.5,0,64/1.5,255)
		end
		if str == ">" then
			ylw=(128+math.random(64))/1.5;
			love.graphics.setColor(ylw,ylw,0)mapdynams.door={};
		end
	end
end]]



function scandoors(x,y)
	for i=1,#mapdynams.door do
		if mapdynams.dx[i]==x and mapdynams.dy[i]==y then
			return i;
		end
	end
end

function playersurr()
	strr = "";
	for yyyy=1,5 do
		for xxxx=1,5 do
			strr = strr..getgrid(player.x-2+xxxx,player.y-2+yyyy)
		end
		strr = strr.."\n";
	end
	return strr;
end

function jump(posx,posy)
	local posxinner = player.x+((posx-player.x)/2)
	local posyinner = player.y+((posy-player.y)/2)
	print(player.x..", "..player.y.."|"..posxinner..", "..posyinner.."|"..posx..", "..posy)
	--if not ((posx>mapx or posy>mapy or posx<1 or posy<1)) then
		if (getgrid(posxinner,posyinner) == "." or getgrid(posxinner,posyinner) == "O") then
			if getgrid(posx,posy)=="." then
				move(posx,posy);
			elseif getgrid(posx,posy)==">" then
				player.levels=player.levels+1;
				map=newmap();
			end
		end
--end
end

function newmap()
	local z = generatemap();
	player.sparking=25;
	player.timer=600;
	player.ro=0;
	return z;
end

function move(posx,posy)
	--print(playersurr())
	if not (posx>mapx or posy>mapy or posx<1 or posy<1) then
		local gg = getgrid(posx,posy);
		if gg == "#" then
			return false;
		elseif gg == "." then
			player.x = posx;
			player.y = posy;
		elseif gg == "+" then
			id = -1;
			id = scandoors(posx,posy);
			if mapdynams.opened[id]==false then
				mapdynams.opened[id]=true;
				return false;
			else
				player.x=posx;
				player.y=posy;
			end
		elseif gg == ">" then
			player.levels=player.levels+1;
			map=newmap();
				while move(math.random(1,mapx),math.random(1,mapy)) == false do
					local nothing="nothing";
				end
		end
	end
end

function hmr(var,num) --Short for "how many rows". Pretty much a ripoff of muldown.
	if var <= num then
	return var;
	end
	local fzz = var;
	times = 0;
	while fzz-num > 0 do
		fzz = fzz - num;
		times = times + 1;
	end
	return times;
end

function muldown(var,num) --This will bring the variable down by num until it can't go down anymore.
	if var <= num then
	return var;
	end
	local fzz = var;
	times = 0;
	while fzz-num > 0 do
		fzz = fzz - num;
		times = times + 1;
	end
	--print("original value "..var..", returning "..fzz);
	return fzz;
end

function drawgame()
	love.graphics.setColor(255,255,255,(player.timer/600)*255);
	--[==[game="";
	for yy=1,25 do
		if yy == player.y then
			for xx=1,player.x-1 do
				game=game..getgrid(xx,yy);
			end
			game=game.."@"
			for xx=1,80-player.x do
				game=game..getgrid(xx+player.x,yy);
			end
		else
			for xx=1,80 do
				game=game..getgrid(xx,yy);
			end
		end
		game=game.."\n";
	end
	love.graphics.print(game,0,0);]==]
	love.graphics.print(map,0,0); --draw map
	--[[for i=0,string.len(string.gsub(map,"\n","")) do
		s = getgrid(muldown(i,mapx)+1,hmr(i,mapx)+1);
		for cc=1,#colors do
			if s==colors[cc][1] then
				love.graphics.setColor(colors[cc][2],colors[cc][3],colors[cc][4]);
				love.graphics.print(colors[cc][1],muldown(i,mapx-1)*6,hmr(i,mapx)*10);
			end
		end
	end]]
	for i=1,#mapdynams.door do
		if mapdynams.door[i] == true and mapdynams.opened[i] == true then
			love.graphics.setColor(0,0,0,255);
			love.graphics.rectangle("fill",(muldown(mapdynams.dx[i],mapx)-1)*6,(mapdynams.dy[i]-1)*10,6,10)
			love.graphics.print("'",(muldown(mapdynams.dx[i],mapx)-1)*6,(mapdynams.dy[i]-1)*10)
		end
	end
	love.graphics.setColor(255,255,255,255);
	love.graphics.rectangle("line",1,1,6*mapx+1,10*mapy+1);
	love.graphics.setColor(0,0,0,255);
	love.graphics.rectangle("fill",(player.x-1)*6,(player.y-1)*10,6,10) --block behind player
	if player.sparking > 0 then
		love.graphics.setColor(math.random(255),math.random(255),math.random(255),180);
		player.sparking = player.sparking - 1;
		love.graphics.rectangle("fill",(player.x-2)*6,(player.y-2)*10,6*3,10*3)
	end
	
	love.graphics.setColor(player.r,player.g,player.b,255);
	--[[player.pos = "";
	for yy=1,player.y do
		if yy < player.y then
			for xx=1,80 do
				player.pos = player.pos..".";
			end
			player.pos = player.pos.."\n";
		else
			for xx=1,player.x-1 do
				player.pos = player.pos..".";
			end
		end
	end
	player.pos = player.pos.."@";
	love.graphics.print(player.pos,0,0)]]
	love.graphics.print(player.symbol,(player.x-1)*6,(player.y-1)*10)--(jumping*3)) --player
	if player.gameover == 1 then
		if player.ro < 2 then
			player.ro=player.ro+0.025;
		end
		love.graphics.setColor(0,0,0,255);
		love.graphics.rectangle("fill",2,2,6*mapx-2,10*mapy-2);
		love.graphics.setColor(player.r,player.g,player.b,255);
		if player.ro > 0.4 then
			love.graphics.print(player.symbol,45*6-(player.ro*5),100+(player.ro*12),-(player.ro-0.4),5,5);
		else
			love.graphics.print(player.symbol,45*6,100,0,5,5);
		end
		love.graphics.setColor(255,255,255,255);
		if player.ro>=1.8 then
		love.graphics.printf("Nice, "..player.name..". You made it down "..player.levels.." levels.",40*6-50,140,100,"center");
		end
	end
end

--[[function drawgame()
	game="";
	love.graphics.setColor(255,255,255,255);
	for yy=1,25 do
		if yy < player.y then
			for xx=1,80 do
				game=game..getgrid(xx,yy);
			end
		elseif yy == player.y then
			for xx=1,player.x-1 do
				game=game..getgrid(xx,yy);
			end
			game=game.."A";
			if player.x < 80 then
				for xx=1,80-player.x do
					game=game..getgrid(xx+player.x,yy);
				end
			end
		else
			for xx=1,80 do
				game=game..getgrid(xx,yy);
			end
		end
	end
	love.graphics.print(game,0,0);
	love.graphics.print("X: "..player.x.."\nY: "..player.y,0,480)
end]]

function drawhud(h)
	
end

function love.keypressed(k,u)
if start == 1 then
	if k == " " then
		start = 0;
		player.ro=0;
		player.gameover=0;
		for i=1,muldown(love.timer.getMicroTime(),9)+1 do
		map=newmap();
		end
		while move(math.random(1,mapx),math.random(1,mapy)) == false do
			local nothing="nothing";
		end
	end
end
if start == 0 then
	--if love.keyboard.isDown("lshift") then
	if k == "lshift" then
		jumping = 1;
	end
	if jumping==1 then
		if k == "kp2" then --jump south
			jump(player.x,player.y+2);
		elseif k == "kp8" then --jump north
			jump(player.x,player.y-2);
		elseif k == "kp6" then --jump east
			jump(player.x+2,player.y);
		elseif k == "kp4" then --jump west
			jump(player.x-2,player.y);
		end
	end
	if love.keyboard.isDown("lshift") == false then
		if k == "kp8" then --north
			move(player.x,player.y-1);
		elseif k == "kp2" then --south
			move(player.x,player.y+1);
		elseif k == "kp6" then --east
			move(player.x+1,player.y);
		elseif k == "kp4" then --west
			move(player.x-1,player.y);
		elseif k == "kp9" then --northeast
			move(player.x+1,player.y-1);
		elseif k == "kp7" then --northwest
			move(player.x-1,player.y-1);
		elseif k == "kp3" then --southeast
			move(player.x+1,player.y+1);
		elseif k == "kp1" then --southwest
			move(player.x-1,player.y+1);
		end
	end
	--[[if k == "r" then --reset
		map=generatemap();
		while move(math.random(1,mapx),math.random(1,mapy)) == false do
		local nothing="nothing";
		end
	end]]
end
end

function love.keyreleased(k)
if start == 0 then
	if k == "lshift" then
		jumping = 0;
	end
end
end

function getgrid(xxx,yyy)
	--if not string.sub(map,xxx+((yyy-1)*80),xxx+((yyy-1)*80)) == "\n" then
	return string.sub(string.gsub(map,"\n",""),xxx+((yyy-1)*80),xxx+((yyy-1)*80));
	--else
	--return "";
	--end
end

function love.update()
	if player.timer > 0 and start == 0 then
		player.timer = player.timer - 1;
		print(player.timer);
		if player.timer ==0 then
			--love.filesystem.write('highscores.txt',player.name..": "..player.levels.."\n");
			player.gameover=1;
			player.start=1;
		end
	elseif start == 1 and player.gameover == 0 then
		player.timer = 600;
	end
	--[[yy=0;
	xx=0;
	game = "";
	for yy=1,25 do
		for xx=1,80 do
			game = game..getgrid(xx,yy);
		end
		--game = game.."\n"
	end]]
end

function love.draw()
	drawgame();
	drawhud(hud);
end
